﻿using System.Linq;
public class FreeBuilding : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.free-building";
    public void Start()
    {
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
    }
    [HarmonyLib.HarmonyPatch(typeof(BlockCreator), "HasEnoughResourcesToBuild", new System.Type[] { typeof(CostMultiple[]) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_BlockCreator_HasEnoughResourcesToBuild_CostMultiple
    {
        static bool Prefix(ref bool __result, ref CostMultiple[] buildCost)
        {
            __result = true;
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(BlockCreator), "HasEnoughResourcesToBuild", new System.Type[] { typeof(Block) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_BlockCreator_HasEnoughResourcesToBuild_Block
    {
        static bool Prefix(ref bool __result, ref Block block)
        {
            __result = true;
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(ColorMenu), "HasEnoughMaterialsToPaint")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_ColorMenu_HasEnoughMaterialsToPaint
    {
        static bool Prefix(ref bool __result)
        {
            __result = true;
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(PaintBrush), "PaintBlock")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_PaintBrush_PaintBlock
    {
        static void Prefix(ref ColorMenu ___colorMenu, ref Block block, ref UnityEngine.Vector3 localLockedPivotPosition, ref SO_ColorValue primary, ref SO_ColorValue secondary, ref int paintSide, ref uint patternIndex, ref bool skipValidChecks)
        {
            ___colorMenu.currentPaintCost.costs = null;
            ___colorMenu.currentPaintCost.redCost = 0;
            ___colorMenu.currentPaintCost.blueCost = 0;
            ___colorMenu.currentPaintCost.yellowCost = 0;
            ___colorMenu.currentPaintCost.whiteCost = 0;
            ___colorMenu.currentPaintCost.blackCost = 0;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(CostCollection), "MeetsRequirements")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_CostCollection_MeetsRequirements
    {
        static bool Prefix(ref bool __result)
        {
            __result = true;
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(ItemInstance_Recipe), "HasEnoughResourcesToCraft")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_ItemInstanceRecipe_HasEnoughResourcesToCraft
    {
        static bool Prefix(ref bool __result)
        {
            __result = true;
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Inventory), "RemoveCostMultiple", new System.Type[] { typeof(CostMultiple[]), typeof(bool) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    [HarmonyLib.HarmonyBefore(new string[] { "com.thmsn.craft-from-all-storage" })]
    public class HarmonyPatch_Inventory_RemoveCostMultiple
    {
        static bool Prefix(ref CostMultiple[] costMultiple, ref bool manipulateCostAmount)
        {
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(RemovePlaceables), "ReturnItemsFromBlock", new System.Type[] { typeof(Block), typeof(Network_Player), typeof(bool) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    [HarmonyLib.HarmonyBefore(new string[] { "com.aidanamite.FullRecycling" })]
    public class HarmonyPatch_RemovePlaceables_ReturnItemsFromBlock
    {
        private class PatchInstruction
        {
            public System.Reflection.Emit.OpCode opCode;
            public string operandString;
            public System.Reflection.Emit.OpCode? newOpCode = null;
            public object newOperand = null;
        }
        private static PatchInstruction[] patchInstructions = new PatchInstruction[]{
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldarg_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "Item_Base buildableItem" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "ItemInstance_Recipe settings_recipe" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "CostMultiple[] get_NewCost()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "CostMultiple[] (28)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Br_S, operandString = "System.Reflection.Emit.Label" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple[] (28)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldelem_Ref },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "CostMultiple (30)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple (30)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "System.Int32 amount" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Conv_R4 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_R4, newOperand = (System.Single) 0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Mul },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Call, operandString = "Int32 CeilToInt(Single)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "System.Int32 (31)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldarg_2 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Brfalse_S, operandString = "System.Reflection.Emit.Label" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldarg_1 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "PlayerInventory get_Inventory()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple (30)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "Item_Base[] items" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldelem_Ref },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "System.String get_UniqueName()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (31)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "Int32 AddItem(System.String, Int32)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Pop },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_1 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Add },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple[] (28)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldlen },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Conv_I4 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Blt_S, operandString = "System.Reflection.Emit.Label" },
        };
        static System.Collections.Generic.IEnumerable<HarmonyLib.CodeInstruction> Transpiler(System.Collections.Generic.IEnumerable<HarmonyLib.CodeInstruction> codeInstructionsEnumerable)
        {
            System.Collections.Generic.List<HarmonyLib.CodeInstruction> codeInstructions = new System.Collections.Generic.List<HarmonyLib.CodeInstruction>(codeInstructionsEnumerable);
            int? startPatch = null;
            int codeLength = codeInstructions.Count;
            int patchLength = patchInstructions.Length;
            for (int codeStart = 0; codeStart < codeLength; codeStart++)
            {
                if (codeStart + patchLength > codeLength)
                {
                    break;
                }
                for (int patchCursor = 0; patchCursor < patchLength; patchCursor++)
                {
                    int codeCursor = codeStart + patchCursor;
                    HarmonyLib.CodeInstruction codeInstruction = codeInstructions[codeCursor];
                    PatchInstruction patchInstruction = patchInstructions[patchCursor];
                    if (codeInstruction.opcode == patchInstruction.opCode && (patchInstruction.operandString == null || codeInstruction.operand.ToString() == patchInstruction.operandString))
                    {
                        if (patchCursor == 0)
                        {
                            startPatch = codeStart;
                        }
                        if (patchCursor == patchLength - 1)
                        {
                            break;
                        }
                    }
                    else
                    {
                        startPatch = null;
                        break;
                    }
                }
                if (startPatch != null)
                {
                    break;
                }
            }
            if (startPatch != null)
            {
                for (int patchCursor = 0; patchCursor < patchLength; patchCursor++)
                {
                    int codeCursor = (int)startPatch + patchCursor;
                    PatchInstruction patchInstruction = patchInstructions[patchCursor];
                    if (patchInstruction.newOpCode != null)
                    {
                        codeInstructions[codeCursor].opcode = (System.Reflection.Emit.OpCode)patchInstruction.newOpCode;
                    }
                    if (patchInstruction.newOperand != null)
                    {
                        codeInstructions[codeCursor].operand = patchInstruction.newOperand;
                    }
                }
            }
            return codeInstructions.AsEnumerable();
        }
    }
}
